import yaml

def load_yaml(yaml_file):
    '''
    Takes a yaml file, it loads the yaml file,
    and inherits any attributes defined in the files listed in the
    inherits tag.
    '''
    # load yaml file
    f = open(yaml_file, 'r')
    params = yaml.load(f)
    f.close()

    # helper func which recursively inherits dictionaries
    def fillDict(_params, _inherit_params):
        for _key, _value in _params.iteritems():
            if type(_value) is dict and _inherit_params.has_key(_key):
                fillDict(_value, _inherit_params[_key])
            else:
                _inherit_params[_key] = _value

    # parse any files listed in the inherits list tag
    if params.has_key('inherits'):
        inherit_params = {}
        base_files = params['inherits'][:]
        base_files.reverse()
        for filename in base_files:
            # fill temp dictionary with inherited attributes
            f = open(filename, 'r')
            base_params = yaml.load(f)
            f.close()

            # values not defined in derived file are pulled from inherited file
            fillDict(inherit_params, base_params)
            inherit_params = base_params

        # fill our dictionary with values inherited
        fillDict(params, inherit_params)


    return inherit_params                       



mydict = load_yaml('test.yml')
print mydict
